std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits > Struct Template Reference
Containers » Unordered Associative » Base and Implementation Classes

`#include <hashtable_policy.h>`

Inheritance diagram for std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >:
[legend]

## Public Member Functions

template<typename _InputIterator >
void | insert (_InputIterator __first, _InputIterator __last)
__ireturn_type | insert (const value_type &__v)
iterator | insert (const_iterator __hint, const value_type &__v)
void | insert (initializer_list< value_type > __l)

## Protected Types

using | __hashtable = _Hashtable< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >
using | __hashtable_base = _Hashtable_base< _Key, _Value, _ExtractKey, _Equal, _H1, _H2, _Hash, _Traits >
using | __ireturn_type = typename __hashtable_base::__ireturn_type
using | __node_alloc_type = __alloc_rebind< _Alloc, __node_type >
using | __node_gen_type = _AllocNode< __node_alloc_type >
using | __node_type = _Hash_node< _Value, _Traits::__hash_cached::value >
using | __unique_keys = typename __hashtable_base::__unique_keys
using | const_iterator = typename __hashtable_base::const_iterator
using | iterator = typename __hashtable_base::iterator
using | size_type = typename __hashtable_base::size_type
using | value_type = typename __hashtable_base::value_type

## Protected Member Functions

__hashtable & | _M_conjure_hashtable ()
template<typename _InputIterator , typename _NodeGetter >
void | _M_insert_range (_InputIterator __first, _InputIterator __last, const _NodeGetter &, false_type)
template<typename _InputIterator , typename _NodeGetter >
void | _M_insert_range (_InputIterator __first, _InputIterator __last, const _NodeGetter &, true_type)

## Detailed Description

template<typename _Key, typename _Value, typename _Alloc, typename _ExtractKey, typename _Equal, typename _H1, typename _H2, typename _Hash, typename _RehashPolicy, typename _Traits>
struct std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >

Primary class template _Insert_base.

Defines `insert` member functions appropriate to all _Hashtables.

Definition at line 782 of file hashtable_policy.h.

## Member Typedef Documentation

## __hashtable

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::__hashtable = _Hashtable<_Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits>

protected

Definition at line 785 of file hashtable_policy.h.

## __hashtable_base

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::__hashtable_base = _Hashtable_base<_Key, _Value, _ExtractKey, _Equal, _H1, _H2, _Hash, _Traits>

protected

Definition at line 789 of file hashtable_policy.h.

## __ireturn_type

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::__ireturn_type = typename __hashtable_base::__ireturn_type

protected

Definition at line 799 of file hashtable_policy.h.

## __node_alloc_type

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::__node_alloc_type = __alloc_rebind<_Alloc, __node_type>

protected

Definition at line 801 of file hashtable_policy.h.

## __node_gen_type

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::__node_gen_type = _AllocNode<__node_alloc_type>

protected

Definition at line 802 of file hashtable_policy.h.

## __node_type

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::__node_type = _Hash_node<_Value, _Traits::__hash_cached::value>

protected

Definition at line 800 of file hashtable_policy.h.

## __unique_keys

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::__unique_keys = typename __hashtable_base::__unique_keys

protected

Definition at line 798 of file hashtable_policy.h.

## const_iterator

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::const_iterator = typename __hashtable_base::const_iterator

protected

Definition at line 795 of file hashtable_policy.h.

## iterator

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::iterator = typename __hashtable_base::iterator

protected

Definition at line 794 of file hashtable_policy.h.

## size_type

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::size_type = typename __hashtable_base::size_type

protected

Definition at line 796 of file hashtable_policy.h.

## value_type

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

using std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::value_type = typename __hashtable_base::value_type

protected

Definition at line 793 of file hashtable_policy.h.

## Member Function Documentation

## _M_conjure_hashtable()

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

__hashtable & std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::_M_conjure_hashtable | ( |  | ) |

inline protected

Definition at line 805 of file hashtable_policy.h.

## insert() [1/4]

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >
template<typename _InputIterator >

void std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) |  |

inline

Definition at line 841 of file hashtable_policy.h.

## insert() [2/4]

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

__ireturn_type std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::insert | ( | const value_type & | __v | ) |

inline

Definition at line 820 of file hashtable_policy.h.

## insert() [3/4]

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

iterator std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::insert | ( | const_iterator | __hint,
|  | const value_type & | __v
| ) |  |

inline

Definition at line 828 of file hashtable_policy.h.

## insert() [4/4]

template<typename _Key , typename _Value , typename _Alloc , typename _ExtractKey , typename _Equal , typename _H1 , typename _H2 , typename _Hash , typename _RehashPolicy , typename _Traits >

void std::__detail::_Insert_base< _Key, _Value, _Alloc, _ExtractKey, _Equal, _H1, _H2, _Hash, _RehashPolicy, _Traits >::insert | ( | initializer_list< value_type > | __l | ) |

inline

Definition at line 836 of file hashtable_policy.h.

The documentation for this struct was generated from the following file:

- hashtable_policy.h